unit schFacturasClienteClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_FacturasCliente = '{8F2BDC76-1E34-41E2-8738-14BA1E7BC9BA}';
  RID_FacturasCliente_Detalles = '{15B6D41F-96C1-4C4E-A224-C2D8F87CD524}';

  { Data table names }
  nme_FacturasCliente = 'FacturasCliente';
  nme_FacturasCliente_Detalles = 'FacturasCliente_Detalles';

  { FacturasCliente fields }
  fld_FacturasClienteID = 'ID';
  fld_FacturasClienteID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasClienteREFERENCIA = 'REFERENCIA';
  fld_FacturasClienteTIPO = 'TIPO';
  fld_FacturasClienteID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_FacturasClienteFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasClienteFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';
  fld_FacturasClienteFECHA_RETENCION = 'FECHA_RETENCION';
  fld_FacturasClienteSITUACION = 'SITUACION';
  fld_FacturasClienteBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasClienteDESCUENTO = 'DESCUENTO';
  fld_FacturasClienteIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasClienteIVA = 'IVA';
  fld_FacturasClienteIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasClienteRE = 'RE';
  fld_FacturasClienteIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasClienteIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasClienteOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasClienteID_CLIENTE = 'ID_CLIENTE';
  fld_FacturasClienteNIF_CIF = 'NIF_CIF';
  fld_FacturasClienteNOMBRE = 'NOMBRE';
  fld_FacturasClienteID_DIRECCION = 'ID_DIRECCION';
  fld_FacturasClienteCALLE = 'CALLE';
  fld_FacturasClientePOBLACION = 'POBLACION';
  fld_FacturasClientePROVINCIA = 'PROVINCIA';
  fld_FacturasClienteCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasClienteDATOS_BANCARIOS = 'DATOS_BANCARIOS';
  fld_FacturasClienteCLIENTE_FINAL = 'CLIENTE_FINAL';
  fld_FacturasClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasClienteUSUARIO = 'USUARIO';
  fld_FacturasClienteID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasClienteRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasClienteID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasClienteIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasClienteIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasClienteID_AGENTE = 'ID_AGENTE';
  fld_FacturasClienteREFERENCIA_COMISION = 'REFERENCIA_COMISION';
  fld_FacturasClienteRETENCION = 'RETENCION';
  fld_FacturasClienteIMPORTE_RETENCION = 'IMPORTE_RETENCION';

  { FacturasCliente field indexes }
  idx_FacturasClienteID = 0;
  idx_FacturasClienteID_EMPRESA = 1;
  idx_FacturasClienteREFERENCIA = 2;
  idx_FacturasClienteTIPO = 3;
  idx_FacturasClienteID_COMISION_LIQUIDADA = 4;
  idx_FacturasClienteFECHA_FACTURA = 5;
  idx_FacturasClienteFECHA_VENCIMIENTO = 6;
  idx_FacturasClienteFECHA_RETENCION = 7;
  idx_FacturasClienteSITUACION = 8;
  idx_FacturasClienteBASE_IMPONIBLE = 9;
  idx_FacturasClienteDESCUENTO = 10;
  idx_FacturasClienteIMPORTE_DESCUENTO = 11;
  idx_FacturasClienteIVA = 12;
  idx_FacturasClienteIMPORTE_IVA = 13;
  idx_FacturasClienteRE = 14;
  idx_FacturasClienteIMPORTE_RE = 15;
  idx_FacturasClienteIMPORTE_TOTAL = 16;
  idx_FacturasClienteOBSERVACIONES = 17;
  idx_FacturasClienteID_CLIENTE = 18;
  idx_FacturasClienteNIF_CIF = 19;
  idx_FacturasClienteNOMBRE = 20;
  idx_FacturasClienteID_DIRECCION = 21;
  idx_FacturasClienteCALLE = 22;
  idx_FacturasClientePOBLACION = 23;
  idx_FacturasClientePROVINCIA = 24;
  idx_FacturasClienteCODIGO_POSTAL = 25;
  idx_FacturasClienteDATOS_BANCARIOS = 26;
  idx_FacturasClienteCLIENTE_FINAL = 27;
  idx_FacturasClienteFECHA_ALTA = 28;
  idx_FacturasClienteFECHA_MODIFICACION = 29;
  idx_FacturasClienteUSUARIO = 30;
  idx_FacturasClienteID_FORMA_PAGO = 31;
  idx_FacturasClienteRECARGO_EQUIVALENCIA = 32;
  idx_FacturasClienteID_TIPO_IVA = 33;
  idx_FacturasClienteIMPORTE_NETO = 34;
  idx_FacturasClienteIMPORTE_PORTE = 35;
  idx_FacturasClienteID_AGENTE = 36;
  idx_FacturasClienteREFERENCIA_COMISION = 37;
  idx_FacturasClienteRETENCION = 38;
  idx_FacturasClienteIMPORTE_RETENCION = 39;

  { FacturasCliente_Detalles fields }
  fld_FacturasCliente_DetallesID = 'ID';
  fld_FacturasCliente_DetallesID_FACTURA = 'ID_FACTURA';
  fld_FacturasCliente_DetallesPOSICION = 'POSICION';
  fld_FacturasCliente_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasCliente_DetallesCONCEPTO = 'CONCEPTO';
  fld_FacturasCliente_DetallesCANTIDAD = 'CANTIDAD';
  fld_FacturasCliente_DetallesUNIDAD_MEDIDA = 'UNIDAD_MEDIDA';
  fld_FacturasCliente_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasCliente_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_DetallesVISIBLE = 'VISIBLE';
  fld_FacturasCliente_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasCliente_DetallesDESCUENTO = 'DESCUENTO';
  fld_FacturasCliente_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasCliente_DetallesREFERENCIA = 'REFERENCIA';
  fld_FacturasCliente_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasCliente_Detalles field indexes }
  idx_FacturasCliente_DetallesID = 0;
  idx_FacturasCliente_DetallesID_FACTURA = 1;
  idx_FacturasCliente_DetallesPOSICION = 2;
  idx_FacturasCliente_DetallesTIPO_DETALLE = 3;
  idx_FacturasCliente_DetallesCONCEPTO = 4;
  idx_FacturasCliente_DetallesCANTIDAD = 5;
  idx_FacturasCliente_DetallesUNIDAD_MEDIDA = 6;
  idx_FacturasCliente_DetallesIMPORTE_UNIDAD = 7;
  idx_FacturasCliente_DetallesIMPORTE_TOTAL = 8;
  idx_FacturasCliente_DetallesVISIBLE = 9;
  idx_FacturasCliente_DetallesID_ARTICULO = 10;
  idx_FacturasCliente_DetallesDESCUENTO = 11;
  idx_FacturasCliente_DetallesIMPORTE_PORTE = 12;
  idx_FacturasCliente_DetallesREFERENCIA = 13;
  idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR = 14;

type
  { IFacturasCliente }
  IFacturasCliente = interface(IDAStronglyTypedDataTable)
  ['{C8AADCF0-C145-435A-A93E-D1B5ECD0BA1B}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetTIPOIsNull: Boolean;
    procedure SetTIPOIsNull(const aValue: Boolean);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAIsNull: Boolean;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetFECHA_FACTURAIsNull: Boolean;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOIsNull: Boolean;
    procedure SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean);
    function GetFECHA_RETENCIONValue: DateTime;
    procedure SetFECHA_RETENCIONValue(const aValue: DateTime);
    function GetFECHA_RETENCIONIsNull: Boolean;
    procedure SetFECHA_RETENCIONIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetBASE_IMPONIBLEIsNull: Boolean;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIMPORTE_DESCUENTOIsNull: Boolean;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIVAIsNull: Boolean;
    procedure SetIVAIsNull(const aValue: Boolean);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetIMPORTE_IVAIsNull: Boolean;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetREIsNull: Boolean;
    procedure SetREIsNull(const aValue: Boolean);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_REIsNull: Boolean;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNIF_CIFIsNull: Boolean;
    procedure SetNIF_CIFIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetID_DIRECCIONValue: Integer;
    procedure SetID_DIRECCIONValue(const aValue: Integer);
    function GetID_DIRECCIONIsNull: Boolean;
    procedure SetID_DIRECCIONIsNull(const aValue: Boolean);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCALLEIsNull: Boolean;
    procedure SetCALLEIsNull(const aValue: Boolean);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPOBLACIONIsNull: Boolean;
    procedure SetPOBLACIONIsNull(const aValue: Boolean);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPROVINCIAIsNull: Boolean;
    procedure SetPROVINCIAIsNull(const aValue: Boolean);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetCODIGO_POSTALIsNull: Boolean;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean);
    function GetDATOS_BANCARIOSValue: String;
    procedure SetDATOS_BANCARIOSValue(const aValue: String);
    function GetDATOS_BANCARIOSIsNull: Boolean;
    procedure SetDATOS_BANCARIOSIsNull(const aValue: Boolean);
    function GetCLIENTE_FINALValue: String;
    procedure SetCLIENTE_FINALValue(const aValue: String);
    function GetCLIENTE_FINALIsNull: Boolean;
    procedure SetCLIENTE_FINALIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetID_FORMA_PAGOIsNull: Boolean;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean);
    function GetRECARGO_EQUIVALENCIAValue: SmallInt;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetID_TIPO_IVAIsNull: Boolean;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_NETOIsNull: Boolean;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetREFERENCIA_COMISIONValue: String;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String);
    function GetREFERENCIA_COMISIONIsNull: Boolean;
    procedure SetREFERENCIA_COMISIONIsNull(const aValue: Boolean);
    function GetRETENCIONValue: Float;
    procedure SetRETENCIONValue(const aValue: Float);
    function GetRETENCIONIsNull: Boolean;
    procedure SetRETENCIONIsNull(const aValue: Boolean);
    function GetIMPORTE_RETENCIONValue: Currency;
    procedure SetIMPORTE_RETENCIONValue(const aValue: Currency);
    function GetIMPORTE_RETENCIONIsNull: Boolean;
    procedure SetIMPORTE_RETENCIONIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property FECHA_VENCIMIENTOIsNull: Boolean read GetFECHA_VENCIMIENTOIsNull write SetFECHA_VENCIMIENTOIsNull;
    property FECHA_RETENCION: DateTime read GetFECHA_RETENCIONValue write SetFECHA_RETENCIONValue;
    property FECHA_RETENCIONIsNull: Boolean read GetFECHA_RETENCIONIsNull write SetFECHA_RETENCIONIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property ID_DIRECCION: Integer read GetID_DIRECCIONValue write SetID_DIRECCIONValue;
    property ID_DIRECCIONIsNull: Boolean read GetID_DIRECCIONIsNull write SetID_DIRECCIONIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property DATOS_BANCARIOS: String read GetDATOS_BANCARIOSValue write SetDATOS_BANCARIOSValue;
    property DATOS_BANCARIOSIsNull: Boolean read GetDATOS_BANCARIOSIsNull write SetDATOS_BANCARIOSIsNull;
    property CLIENTE_FINAL: String read GetCLIENTE_FINALValue write SetCLIENTE_FINALValue;
    property CLIENTE_FINALIsNull: Boolean read GetCLIENTE_FINALIsNull write SetCLIENTE_FINALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property REFERENCIA_COMISIONIsNull: Boolean read GetREFERENCIA_COMISIONIsNull write SetREFERENCIA_COMISIONIsNull;
    property RETENCION: Float read GetRETENCIONValue write SetRETENCIONValue;
    property RETENCIONIsNull: Boolean read GetRETENCIONIsNull write SetRETENCIONIsNull;
    property IMPORTE_RETENCION: Currency read GetIMPORTE_RETENCIONValue write SetIMPORTE_RETENCIONValue;
    property IMPORTE_RETENCIONIsNull: Boolean read GetIMPORTE_RETENCIONIsNull write SetIMPORTE_RETENCIONIsNull;
  end;

  { TFacturasClienteDataTableRules }
  TFacturasClienteDataTableRules = class(TIntfObjectDADataTableRules, IFacturasCliente)
  private
    f_OBSERVACIONES: IROStrings;
    procedure OBSERVACIONES_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTIPOIsNull: Boolean; virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAIsNull: Boolean; virtual;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetFECHA_FACTURAIsNull: Boolean; virtual;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOIsNull: Boolean; virtual;
    procedure SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean); virtual;
    function GetFECHA_RETENCIONValue: DateTime; virtual;
    procedure SetFECHA_RETENCIONValue(const aValue: DateTime); virtual;
    function GetFECHA_RETENCIONIsNull: Boolean; virtual;
    procedure SetFECHA_RETENCIONIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetBASE_IMPONIBLEIsNull: Boolean; virtual;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIMPORTE_DESCUENTOIsNull: Boolean; virtual;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIVAIsNull: Boolean; virtual;
    procedure SetIVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetIMPORTE_IVAIsNull: Boolean; virtual;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetREIsNull: Boolean; virtual;
    procedure SetREIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_REIsNull: Boolean; virtual;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNIF_CIFIsNull: Boolean; virtual;
    procedure SetNIF_CIFIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetID_DIRECCIONValue: Integer; virtual;
    procedure SetID_DIRECCIONValue(const aValue: Integer); virtual;
    function GetID_DIRECCIONIsNull: Boolean; virtual;
    procedure SetID_DIRECCIONIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCALLEIsNull: Boolean; virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetDATOS_BANCARIOSValue: String; virtual;
    procedure SetDATOS_BANCARIOSValue(const aValue: String); virtual;
    function GetDATOS_BANCARIOSIsNull: Boolean; virtual;
    procedure SetDATOS_BANCARIOSIsNull(const aValue: Boolean); virtual;
    function GetCLIENTE_FINALValue: String; virtual;
    procedure SetCLIENTE_FINALValue(const aValue: String); virtual;
    function GetCLIENTE_FINALIsNull: Boolean; virtual;
    procedure SetCLIENTE_FINALIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetRECARGO_EQUIVALENCIAValue: SmallInt; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt); virtual;
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean; virtual;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAIsNull: Boolean; virtual;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_NETOIsNull: Boolean; virtual;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_COMISIONValue: String; virtual;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String); virtual;
    function GetREFERENCIA_COMISIONIsNull: Boolean; virtual;
    procedure SetREFERENCIA_COMISIONIsNull(const aValue: Boolean); virtual;
    function GetRETENCIONValue: Float; virtual;
    procedure SetRETENCIONValue(const aValue: Float); virtual;
    function GetRETENCIONIsNull: Boolean; virtual;
    procedure SetRETENCIONIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_RETENCIONValue: Currency; virtual;
    procedure SetIMPORTE_RETENCIONValue(const aValue: Currency); virtual;
    function GetIMPORTE_RETENCIONIsNull: Boolean; virtual;
    procedure SetIMPORTE_RETENCIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property FECHA_VENCIMIENTOIsNull: Boolean read GetFECHA_VENCIMIENTOIsNull write SetFECHA_VENCIMIENTOIsNull;
    property FECHA_RETENCION: DateTime read GetFECHA_RETENCIONValue write SetFECHA_RETENCIONValue;
    property FECHA_RETENCIONIsNull: Boolean read GetFECHA_RETENCIONIsNull write SetFECHA_RETENCIONIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property ID_DIRECCION: Integer read GetID_DIRECCIONValue write SetID_DIRECCIONValue;
    property ID_DIRECCIONIsNull: Boolean read GetID_DIRECCIONIsNull write SetID_DIRECCIONIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property DATOS_BANCARIOS: String read GetDATOS_BANCARIOSValue write SetDATOS_BANCARIOSValue;
    property DATOS_BANCARIOSIsNull: Boolean read GetDATOS_BANCARIOSIsNull write SetDATOS_BANCARIOSIsNull;
    property CLIENTE_FINAL: String read GetCLIENTE_FINALValue write SetCLIENTE_FINALValue;
    property CLIENTE_FINALIsNull: Boolean read GetCLIENTE_FINALIsNull write SetCLIENTE_FINALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property REFERENCIA_COMISIONIsNull: Boolean read GetREFERENCIA_COMISIONIsNull write SetREFERENCIA_COMISIONIsNull;
    property RETENCION: Float read GetRETENCIONValue write SetRETENCIONValue;
    property RETENCIONIsNull: Boolean read GetRETENCIONIsNull write SetRETENCIONIsNull;
    property IMPORTE_RETENCION: Currency read GetIMPORTE_RETENCIONValue write SetIMPORTE_RETENCIONValue;
    property IMPORTE_RETENCIONIsNull: Boolean read GetIMPORTE_RETENCIONIsNull write SetIMPORTE_RETENCIONIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Detalles }
  IFacturasCliente_Detalles = interface(IDAStronglyTypedDataTable)
  ['{F9994FFA-FB1C-4221-A444-441E23C4E2AD}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetPOSICIONIsNull: Boolean;
    procedure SetPOSICIONIsNull(const aValue: Boolean);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetTIPO_DETALLEIsNull: Boolean;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCONCEPTOIsNull: Boolean;
    procedure SetCONCEPTOIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Float;
    procedure SetCANTIDADValue(const aValue: Float);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetUNIDAD_MEDIDAValue: String;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String);
    function GetUNIDAD_MEDIDAIsNull: Boolean;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetIMPORTE_UNIDADIsNull: Boolean;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetVISIBLEIsNull: Boolean;
    procedure SetVISIBLEIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
  end;

  { TFacturasCliente_DetallesDataTableRules }
  TFacturasCliente_DetallesDataTableRules = class(TIntfObjectDADataTableRules, IFacturasCliente_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetPOSICIONIsNull: Boolean; virtual;
    procedure SetPOSICIONIsNull(const aValue: Boolean); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetTIPO_DETALLEIsNull: Boolean; virtual;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCONCEPTOIsNull: Boolean; virtual;
    procedure SetCONCEPTOIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Float; virtual;
    procedure SetCANTIDADValue(const aValue: Float); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetUNIDAD_MEDIDAValue: String; virtual;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String); virtual;
    function GetUNIDAD_MEDIDAIsNull: Boolean; virtual;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTE_UNIDADIsNull: Boolean; virtual;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetVISIBLEIsNull: Boolean; virtual;
    procedure SetVISIBLEIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TFacturasClienteDataTableRules }
constructor TFacturasClienteDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);
end;

destructor TFacturasClienteDataTableRules.Destroy;
begin
  inherited;
end;

procedure TFacturasClienteDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

function TFacturasClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_EMPRESA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteREFERENCIA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteTIPO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteTIPO].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetTIPOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteTIPO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteTIPO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_COMISION_LIQUIDADAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_VENCIMIENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetFECHA_RETENCIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_RETENCION].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_RETENCIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_RETENCION].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_RETENCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_RETENCION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_RETENCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteFECHA_RETENCION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteSITUACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteSITUACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteSITUACION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteSITUACION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetBASE_IMPONIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteDESCUENTO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteDESCUENTO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_DESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIVA].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIVA].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIVA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIVA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteRE].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteRE].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetREIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteRE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteRE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_RE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_REIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_RE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_REIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_RE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsString;
end;

function TFacturasClienteDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteOBSERVACIONES].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_CLIENTE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetNIF_CIFIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteNIF_CIF].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetNIF_CIFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteNIF_CIF].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNOMBRE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNOMBRE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteNOMBRE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteNOMBRE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_DIRECCIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_DIRECCION].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_DIRECCIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_DIRECCION].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_DIRECCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_DIRECCION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_DIRECCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_DIRECCION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCALLE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCALLE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteCALLE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteCALLE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePOBLACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePOBLACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPOBLACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClientePOBLACION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClientePOBLACION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePROVINCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePROVINCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPROVINCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClientePROVINCIA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClientePROVINCIA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCODIGO_POSTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetDATOS_BANCARIOSValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteDATOS_BANCARIOS].AsString;
end;

procedure TFacturasClienteDataTableRules.SetDATOS_BANCARIOSValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteDATOS_BANCARIOS].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetDATOS_BANCARIOSIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteDATOS_BANCARIOS].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetDATOS_BANCARIOSIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteDATOS_BANCARIOS].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetCLIENTE_FINALValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCLIENTE_FINAL].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCLIENTE_FINALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCLIENTE_FINAL].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCLIENTE_FINALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteCLIENTE_FINAL].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetCLIENTE_FINALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteCLIENTE_FINAL].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_ALTA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteUSUARIO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteUSUARIO].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteUSUARIO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteUSUARIO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_FORMA_PAGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetRECARGO_EQUIVALENCIAValue: SmallInt;
begin
  result := DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].AsSmallInt;
end;

procedure TFacturasClienteDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].AsSmallInt := aValue;
end;

function TFacturasClienteDataTableRules.GetRECARGO_EQUIVALENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_TIPO_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_TIPO_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_AGENTE].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_AGENTE].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteID_AGENTE].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteID_AGENTE].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetREFERENCIA_COMISIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIA_COMISIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetREFERENCIA_COMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIA_COMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetRETENCIONValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteRETENCION].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetRETENCIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteRETENCION].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetRETENCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteRETENCION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetRETENCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteRETENCION].AsVariant := Null;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_RETENCIONValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_RETENCION].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_RETENCIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_RETENCION].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_RETENCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_RETENCION].IsNull;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_RETENCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasClienteIMPORTE_RETENCION].AsVariant := Null;
end;


{ TFacturasCliente_DetallesDataTableRules }
constructor TFacturasCliente_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesID].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetPOSICIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetPOSICIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetTIPO_DETALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetTIPO_DETALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCONCEPTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCONCEPTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetCANTIDADValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCANTIDADValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetUNIDAD_MEDIDAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesUNIDAD_MEDIDA].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetUNIDAD_MEDIDAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesUNIDAD_MEDIDA].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetUNIDAD_MEDIDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesUNIDAD_MEDIDA].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesUNIDAD_MEDIDA].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_UNIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetVISIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetVISIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].AsVariant := Null;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_FacturasCliente, TFacturasClienteDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Detalles, TFacturasCliente_DetallesDataTableRules);

end.
